package javax.xhttps;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import java.security.KeyStore;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLEngine;
import javax.net.ssl.SSLParameters;
import javax.net.ssl.TrustManagerFactory;


import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpServer;
import com.sun.net.httpserver.HttpsConfigurator;
import com.sun.net.httpserver.HttpsParameters;
import com.sun.net.httpserver.HttpsServer;
/**
 * xhttps : a tutorial project/ technical note about Java HTTP server.
 * 1. Zhikai Wang/www.heteroclinic.net does not claim any right upon this file and the whole integrated package (zip or tar).
 * 2. The liability of Zhikai Wang/www.heteroclinic.net to the maximum is to remove/modify matters in dispute.
 * 3. All third-party rights and licenses are automatically cascaded.
 * Based on 1,2 and 3, you can do anything with this file and the whole integrated package (zip or tar).
 * Nov 30, 2013 PST
 * This file put two servers functionality in one service.
 */

// A cron thread to start/stop http server
// access http://127.0.0.1:8000/test 
class PlainHttpServerTask extends Task {
    static class PlainHttpTaskHandler implements HttpHandler {
        public void handle(HttpExchange t) throws IOException {
            String echo = "PlainHttp echo~~";
            t.sendResponseHeaders(200, echo.length()); 
            OutputStream os = t.getResponseBody();
            os.write(echo.getBytes());
            os.close();
        }
    }
	@Override
	public void run() {
		System.out.println("PlainHttpTask " + this.iD + " started. Thread id "+Thread.currentThread().getId());

		HttpServer server = null; 
		try {
	        
			server = HttpServer.create(new InetSocketAddress(8000), 0);
	        server.createContext("/test", new PlainHttpTaskHandler());
	        server.setExecutor(null);
	        server.start();
	        
	        
	        // you can use an Object instance as semphore, but in Windows some time it causes problem from modifications by some smart weirdoers.
			while (!Thread.interrupted() && !requestedStop && !otherStop) {
				try {
					TimeUnit.MILLISECONDS.sleep(200);
					
					
					
				} catch (InterruptedException e) {
					throw e;
				} catch (Exception e) {
					// show or not?
					//throw e;
					otherStop = true;
				}
			}
		} catch (Exception e) {
			// eat it
		} finally {
			if (null != server) //TODO use netstat to verify
				server.stop(0);
			
			// logger or not, finally a correct service script re-direct all out streams to the log. namely 1>>log.txt 2>>log.txt e.g.
			System.out.println("PlainHttpTask " + this.iD + " ended. Thread id "+Thread.currentThread().getId()+
					"\nStatus: [Thread.interrupted(),requestedStop,otherStop]=["+Thread.interrupted()+","+requestedStop+","+otherStop+"]");
		}
	}
}
//A cron thread to start/stop SSL http server
//access https://127.0.0.1:4883/test
class SSLHttpServerTask extends Task {
    static class SSLHttpTaskHandler implements HttpHandler {
        public void handle(HttpExchange t) throws IOException {
            String response = "This is secure handler.";
            t.sendResponseHeaders(200, response.length());
            OutputStream os = t.getResponseBody();
            os.write(response.getBytes());
            os.close();
        }
    }
	@Override
	public void run() {
		System.out.println("SSLHttpServerTask " + this.iD + " started. Thread id "+Thread.currentThread().getId());

		HttpsServer httpsServer= null;
		try {
            InetSocketAddress address = new InetSocketAddress(4883);
            httpsServer = HttpsServer.create ( address, 0 );
            SSLContext sslContext = SSLContext.getInstance ( "TLS" );
            char[] password = "xhttps".toCharArray ();
            KeyStore ks = KeyStore.getInstance ( "JKS" );
            
//            //resourcesloader.class.getClassLoader().getResource("package1/resources/repository/SSL-Key/cert.jks").toString();
//    	    System.out.println( "this.getClass().getResource(\"xhttps.jks\") ::" +this.getClass().getResource("src/main/resources/xhttps.jks"));
//    	    System.out.println( " HybridHttpServer ::" + HybridHttpServer.class.getResource("src/main/resources/xhttps.jks"));
//    	    System.out.println( " HybridHttpServer ::" + HybridHttpServer.class.getResource(""));//returns HybridHttpServer ::file:/C:/eclipseworkspace/xhttps/target/classes/javax/xhttps/
//			System.out.println( "Thread.currentThread().getContextClassLoader() ::"+ClassLoader.getSystemResource("xhttps.jks"));
    	    
    	   
            //FileInputStream fis = new FileInputStream ( "C:\\eclipseworkspace\\xhttps\\xhttps.jks" );
            System.out.println("ClassLoader.getSystemResource(\"xhttps.jks\").getFile()"+ClassLoader.getSystemResource("xhttps.jks").getFile());
            //System.out.println("ClassLoader.getSystemResource(\"xhttps.jks\").getFile()"+ClassLoader.getSystemResource("/xhttps.jks").getFile());
            //System.out.println("ClassLoader.getSystemResource(\"\").getFile()"+ClassLoader.getSystemResource("").getFile());
            
            String keyfn = ClassLoader.getSystemResource("xhttps.jks").getFile();
//            System.out.println("this.getClass().getClassLoader().getResource(\"\").getFile()"+
//       			 this.getClass().getClassLoader().getResource("").getFile());
            FileInputStream fis = null;
//            if (keyfn == null ) {
////            	 System.out.println("this.getClass().getClassLoader().getResource(\"/xhttps.jks\").getFile()"+
////            			 this.getClass().getClassLoader().getResource("/xhttps.jks").getFile());
////            	keyfn = this.getClass().getClassLoader().getResource("/xhttps.jks").getFile();
//            	fis = (FileInputStream) this.getClass().getResourceAsStream("/xhttps.jks");
//            }
//            else 
            // to load system resource file (Eclipse) and jar resource file, we have to treat differently. 
            try {
            	fis = new FileInputStream ( keyfn );
            } catch (Exception e) {// eat it 
            	//e.printStackTrace();
            }
            if (fis == null)
            	ks.load( this.getClass().getResourceAsStream("/xhttps.jks"), password );
            else {
            	ks.load ( fis, password );
            }

            KeyManagerFactory kmf = KeyManagerFactory.getInstance ( "SunX509" );
            kmf.init ( ks, password );
            TrustManagerFactory tmf = TrustManagerFactory.getInstance ( "SunX509" );
            tmf.init ( ks );
            sslContext.init ( kmf.getKeyManagers (), tmf.getTrustManagers (), null );
            httpsServer.setHttpsConfigurator ( new HttpsConfigurator( sslContext )
            {
                public void configure ( HttpsParameters params )
                {
                    try
                    {
                        SSLContext c = SSLContext.getDefault ();
                        SSLEngine engine = c.createSSLEngine ();
                        params.setNeedClientAuth ( false );
                        params.setCipherSuites ( engine.getEnabledCipherSuites () );
                        params.setProtocols ( engine.getEnabledProtocols () );
                        SSLParameters defaultSSLParameters = c.getDefaultSSLParameters ();
                        engine.setSSLParameters(defaultSSLParameters);
                    }
                    catch ( Exception ex )
                    {
                    	ex.printStackTrace();
                    }
                }
            } );
            httpsServer.createContext("/test", new SSLHttpTaskHandler());
            httpsServer.setExecutor(null); // creates a default executor
            httpsServer.start();
	        // you can use an Object instance as semphore, but in Windows some time it causes problem from modifications by some smart weirdoers.
			while (!Thread.interrupted() && !requestedStop && !otherStop) {
				try {
					TimeUnit.MILLISECONDS.sleep(200);
				} catch (InterruptedException e) {
					throw e;
				} catch (Exception e) {
					// show or not?
					//throw e;
					otherStop = true;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (null != httpsServer) //TODO use netstat to verify
				httpsServer.stop(0);
			
			// logger or not, finally a correct service script re-direct all out streams to the log. namely 1>>log.txt 2>>log.txt e.g.
			System.out.println("SSLHttpServerTask " + this.iD + " ended. Thread id "+Thread.currentThread().getId()+
					"\nStatus: [Thread.interrupted(),requestedStop,otherStop]=["+Thread.interrupted()+","+requestedStop+","+otherStop+"]");
		}
	}
}


public class HybridHttpServer {
	static List<Future<?>> fl = new ArrayList<Future<?>>();
	static ExecutorService exec = Executors.newCachedThreadPool();
	
	static class HybridHttpServerShutdownHook extends Thread {// must be static

	
		public HybridHttpServerShutdownHook() {
		}

		@Override
		public void run() {
			try {
				Thread.currentThread().setName(
						"SHUTDOWNHOOK: TID-" + Thread.currentThread().getId());
				exec.shutdown();
				for (Future<?> f: fl)
					f.cancel(true);

			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				
				System.out.println(this.getName() + " ended.");
				try {
					TimeUnit.SECONDS.sleep(1);// to flush outstreams
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {

		fl.add(exec.submit(new PlainHttpServerTask()));
		fl.add(exec.submit(new SSLHttpServerTask()));
		
		
	    Runtime.getRuntime().addShutdownHook(
	                new HybridHttpServerShutdownHook());
	    
	    
	   
	    
		// The two ways to stop a server.
		// why use console, Eclipse shields ctrl-c
		// why shutdown hook, as a system service run without console, you can "service xhttps start/stop/restart"
		System.out.println("Type stop or use ctrl-c to terminate the service. ctrl-c not work in Eclipse");
		String condition = "";
		while (!condition.equalsIgnoreCase("stop")) {
			try {
				// create the Scanner
				Scanner scanner = new Scanner(System.in);

				// read input
				condition = scanner.nextLine();
			} catch (Throwable t) {
				t.printStackTrace();
				condition = "stop";
			}
		}

		// TO!DO call clean up
		exec.shutdown();
		for (Future<?> f: fl)
			f.cancel(true);
		//System.out.println("If shutdown hook is called this line won't be called.");

	}

}
// a squirrel tried to pass the meadow maybe for a new nuts venture as for fame of diligence as for faim winter. 
// Two geese wild walked elegantly and talked in grace in the front. That made the squirrel feel angry.
// Maybe the post-venture afternoon dried nut time, the squirrel may understand hopefully.
// That is all about an angry moose scared the geese at the bush near a forest at the border of the Northern Territory.
// The stack is just so long that some lines are missed. Try to understand it make you angry.