package javax.xhttps;
import java.io.IOException;
import java.io.OutputStream;
import java.net.InetSocketAddress;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpServer;
/**
 * xhttps : a tutorial project/ technical note about Java HTTP server.
 * 1. Zhikai Wang/www.heteroclinic.net does not claim any right upon this file and the whole integrated package (zip or tar).
 * 2. The liability of Zhikai Wang/www.heteroclinic.net to the maximum is to remove/modify matters in dispute.
 * 3. All third-party rights and licenses are automatically cascaded.
 * Based on 1,2 and 3, you can do anything with this file and the whole integrated package (zip or tar).
 * Nov 25, 2013    
 * Please refer to the following link about this file's origin. 
 * http://docs.oracle.com/javase/7/docs/jre/api/net/httpserver/spec/com/sun/net/httpserver/package-summary.html -- retrieved on Nov 25, 2013
 * We comment: the above material is Maven-able to resolve the proper dependencies under fair use condition for science and technology promotion purpose.
  * Open a browser and use this link to test result: http://127.0.0.1:8000/test 
 */
public class SimpleHttpServer {
	   public static void main(String[] args) throws Exception {
		   // The following is a simple  HTTP server
	        HttpServer server = HttpServer.create(new InetSocketAddress(8000), 0);
	        server.createContext("/test", new MyHandler());
	        server.setExecutor(null);
	        server.start();
	    }

	    static class MyHandler implements HttpHandler {
	        public void handle(HttpExchange t) throws IOException {
	            String echo = "Eecchhoo~~";
	            t.sendResponseHeaders(200, echo.length()); 
	            OutputStream os = t.getResponseBody();
	            os.write(echo.getBytes());
	            os.close();
	        }
	    }
}
